# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['deutschland',
 'deutschland.studiensuche',
 'deutschland.studiensuche.api',
 'deutschland.studiensuche.apis',
 'deutschland.studiensuche.model',
 'deutschland.studiensuche.models']

package_data = \
{'': ['*']}

install_requires = \
['python-dateutil', 'urllib3>=1.25.3']

setup_kwargs = {
    'name': 'de-studiensuche',
    'version': '0.1.0',
    'description': 'Arbeitsagentur Studiensuche API',
    'long_description': '# studiensuche\nEine der größten Datenbanken für Studienangebote in Deutschland durchsuchen. \n\nDie Authentifizierung funktioniert per OAuth 2 Client Credentials mit JWTs. Folgende Client-Credentials können dafür verwendet werden:\n\n**ClientID:** 5aee2cfe-1709-48a9-951d-eb48f8f73a74\n\n**ClientSecret:** 3309a57a-9214-40db-9abe-28b1bb30c08c\n\n**Achtung**: der generierte Token muss bei folgenden GET-requests an https://rest.arbeitsagentur.de/infosysbub/studisu/pc/v1/studienangebote im header als \'OAuthAccessToken\' inkludiert werden.\n\n\nThis Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:\n\n- API version: 1.0.0\n- Package version: 0.1.0\n- Build package: org.openapitools.codegen.languages.PythonClientCodegen\nFor more information, please visit [https://github.com/AndreasFischer1985/studiensuche-api](https://github.com/AndreasFischer1985/studiensuche-api)\n\n## Requirements.\n\nPython >= 3.6\n\n## Installation & Usage\n### pip install\n\n```sh\npip install deutschland[studiensuche]\n```\n\n### poetry install\n\n```sh\npoetry add deutschland -E studiensuche\n```\n\n### Setuptools\n\nInstall via [Setuptools](http://pypi.python.org/pypi/setuptools).\n\n```sh\npython setup.py install --user\n```\n(or `sudo python setup.py install` to install the package for all users)\n\n## Usage\n\nImport the package:\n```python\nfrom deutschland import studiensuche\n```\n\n## Getting Started\n\nPlease follow the [installation procedure](#installation--usage) and then run the following:\n\n```python\n\nimport time\nfrom deutschland import studiensuche\nfrom pprint import pprint\nfrom deutschland.studiensuche.api import default_api\nfrom deutschland.studiensuche.model.response import Response\n# Defining the host is optional and defaults to https://rest.arbeitsagentur.de/infosysbub/studisu\n# See configuration.py for a list of all supported configuration parameters.\nconfiguration = studiensuche.Configuration(\n    host = "https://rest.arbeitsagentur.de/infosysbub/studisu"\n)\n\n# The client must configure the authentication and authorization parameters\n# in accordance with the API server security policy.\n# Examples for each auth method are provided below, use the example that\n# satisfies your auth use case.\n\n# Configure OAuth2 access token for authorization: clientCredAuth\nconfiguration = studiensuche.Configuration(\n    host = "https://rest.arbeitsagentur.de/infosysbub/studisu"\n)\nconfiguration.access_token = \'YOUR_ACCESS_TOKEN\'\n\n\n# Enter a context with an instance of the API client\nwith studiensuche.ApiClient(configuration) as api_client:\n    # Create an instance of the API class\n    api_instance = default_api.DefaultApi(api_client)\n    sw = "Informatikberufe" # str | Suchwort (optional)\n    sfa = 93683 # int | Studienfach-ID (optional)\n    sfe = "94175;94350" # str | dkzIds einer Studienfeld(gruppe), idR. zwei Semikolon-getrennte Werte je Studienfeld(gruppe) (optional)\n    orte = "Feucht_90537_11.224918_49.376701" # str | Ortsangabe nebst Postleitzahl und Koordinaten (optional)\n    pg = 1 # int | Ergebnissseite (optional)\n    uk = "Bundesweit" # str | Umkreis - Bundesweit=Bundesweit, 25=25 km, 50=50 km, 100=100 km, 150=150 km, 200=200 km. (optional)\n    re = "BW" # str | Region/Bundesland - BW=Baden-Württemberg, BY=Bayern, BE=Berlin, BB=Brandenburg, HB=Bremen, HH=Hamburg, HE=Hessen, MV=Mecklenburg-Vorpommern, NI=Niedersachsen, NW=Nordrhei-Westfalen, RP=Rheinland-Pfalz, SL=Saarland, SN=Sachsen, ST=Sachsen-Anhalt, SH=Schleswig-Holstein, TH=Thüringen. Mehrere Komma-getrennte Angaben möglich. (optional)\n    sfo = 1 # int | Studienform - 1=Vollzeitstudium, 2=Teilzeitstudium, 3=Wochenendveranstaltung, 4=Fernstudium, 5=Selbststudium. Mehrere Semikolon-getrennte Angaben möglich. (optional)\n    st = 1 # int | Studientyp - 0=Studiengang grundständig, 1=Studiengang weiterführend. (optional)\n    smo = 5 # int | Studiengangmodell - 1=ausbildungsintegrierend, 2=berufsintegrierend, 3=berufsbegleitend, 4=praxisintegrierend, 5=Duales Studium allgemein. Mehrere Semikolon-getrennte Angaben möglich. (optional)\n    abg = 0 # int | Studiengangsabschlussgrad - 0=ohne Angabe, 1=Abschlussprüfung, 2=Bachelor, 3=Diplom, 4=Diplom(FH), 10=Master, 12=Staatsexamen (optional)\n    hsa = 108 # int | Hochschulart - 101=Berufsakademie/Duale Hochschule, 106=FH/FAW, 107=Kunst- und Musikhochschule, 108=Universität, 111=Verwaltungshochschule, 113=Private Hochschule. 114=Hochschule eigenen Typs. Mehrere Semikolon-getrennte Angaben möglich. (optional)\n    san = 26218 # int | Studienanbieter-ID (optional)\n    ffst = 1 # int | Eignungstest - 1=Studiencheck, 2=OSA. Mehrere Semikolon-getrennte Angaben möglich. (optional)\n\n    try:\n        # Studiensuche\n        api_response = api_instance.studiensuche(sw=sw, sfa=sfa, sfe=sfe, orte=orte, pg=pg, uk=uk, re=re, sfo=sfo, st=st, smo=smo, abg=abg, hsa=hsa, san=san, ffst=ffst)\n        pprint(api_response)\n    except studiensuche.ApiException as e:\n        print("Exception when calling DefaultApi->studiensuche: %s\\n" % e)\n```\n\n## Documentation for API Endpoints\n\nAll URIs are relative to *https://rest.arbeitsagentur.de/infosysbub/studisu*\n\nClass | Method | HTTP request | Description\n------------ | ------------- | ------------- | -------------\n*DefaultApi* | [**studiensuche**](docs/DefaultApi.md#studiensuche) | **GET** /pc/v1/studienangebote | Studiensuche\n\n\n## Documentation For Models\n\n - [Response](docs/Response.md)\n - [ResponseAuswahl](docs/ResponseAuswahl.md)\n - [ResponseFacetten](docs/ResponseFacetten.md)\n - [ResponseItems](docs/ResponseItems.md)\n - [ResponseStudienangebot](docs/ResponseStudienangebot.md)\n - [ResponseStudienangebotAbschlussgrad](docs/ResponseStudienangebotAbschlussgrad.md)\n - [ResponseStudienangebotHochschulart](docs/ResponseStudienangebotHochschulart.md)\n - [ResponseStudienangebotRegion](docs/ResponseStudienangebotRegion.md)\n - [ResponseStudienangebotStudienanbieter](docs/ResponseStudienangebotStudienanbieter.md)\n - [ResponseStudienangebotStudienanbieterLogo](docs/ResponseStudienangebotStudienanbieterLogo.md)\n - [ResponseStudienangebotStudienform](docs/ResponseStudienangebotStudienform.md)\n - [ResponseStudienangebotStudienmodelle](docs/ResponseStudienangebotStudienmodelle.md)\n - [ResponseStudienangebotStudienort](docs/ResponseStudienangebotStudienort.md)\n - [ResponseStudienangebotStudienortLocation](docs/ResponseStudienangebotStudienortLocation.md)\n - [ResponseStudienangebotStudientyp](docs/ResponseStudienangebotStudientyp.md)\n\n\n## Documentation For Authorization\n\n\n## clientCredAuth\n\n- **Type**: OAuth\n- **Flow**: application\n- **Authorization URL**: \n- **Scopes**: N/A\n\n\n## Author\n\nandreasfischer1985@web.de\n\n\n## Notes for Large OpenAPI documents\nIf the OpenAPI document is large, imports in studiensuche.apis and studiensuche.models may fail with a\nRecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:\n\nSolution 1:\nUse specific imports for apis and models like:\n- `from deutschland.studiensuche.api.default_api import DefaultApi`\n- `from deutschland.studiensuche.model.pet import Pet`\n\nSolution 2:\nBefore importing the package, adjust the maximum recursion limit as shown below:\n```\nimport sys\nsys.setrecursionlimit(1500)\nfrom deutschland import studiensuche\nfrom deutschland.studiensuche.apis import *\nfrom deutschland.studiensuche.models import *\n```\n\n',
    'author': 'BundesAPI',
    'author_email': 'kontakt@bund.dev',
    'maintainer': None,
    'maintainer_email': None,
    'url': 'https://github.com/bundesAPI/studiensuche-api',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.6',
}


setup(**setup_kwargs)
